VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Source I, Measure R with SourceMeter Instruments"
   ClientHeight    =   6330
   ClientLeft      =   1950
   ClientTop       =   2010
   ClientWidth     =   6870
   LinkTopic       =   "Form1"
   ScaleHeight     =   6330
   ScaleWidth      =   6870
   Begin VB.Frame Frame2 
      Caption         =   "NPLC (power line cycles)"
      Height          =   1815
      Left            =   720
      TabIndex        =   10
      ToolTipText     =   "Power Line Cycles: tradeoff between speed and resolution"
      Top             =   1680
      Width           =   2175
      Begin VB.OptionButton optNPLC 
         Caption         =   "10 (SLOW)"
         Height          =   195
         Index           =   3
         Left            =   240
         TabIndex        =   14
         Top             =   1440
         Width           =   1815
      End
      Begin VB.OptionButton optNPLC 
         Caption         =   "1.0 (MEDIUM)"
         Height          =   195
         Index           =   2
         Left            =   240
         TabIndex        =   13
         Top             =   1080
         Value           =   -1  'True
         Width           =   1815
      End
      Begin VB.OptionButton optNPLC 
         Caption         =   "0.1 ( FAST)"
         Height          =   195
         Index           =   1
         Left            =   240
         TabIndex        =   12
         Top             =   720
         Width           =   1815
      End
      Begin VB.OptionButton optNPLC 
         Caption         =   "0.01 (VERY FAST)"
         Height          =   195
         Index           =   0
         Left            =   240
         TabIndex        =   11
         Top             =   360
         Width           =   1815
      End
   End
   Begin VB.Frame Frame1 
      Caption         =   "Resistance Mode"
      Height          =   855
      Left            =   3120
      TabIndex        =   7
      Top             =   1680
      Width           =   1935
      Begin VB.OptionButton opt4WIRE 
         Caption         =   "4-Wire"
         Height          =   255
         Left            =   240
         TabIndex        =   9
         Top             =   480
         Width           =   975
      End
      Begin VB.OptionButton opt2WIRE 
         Caption         =   "2-wire"
         Height          =   195
         Left            =   240
         TabIndex        =   8
         Top             =   240
         Value           =   -1  'True
         Width           =   855
      End
   End
   Begin VB.CommandButton cmdClose 
      Caption         =   "Close Session"
      Height          =   375
      Left            =   720
      TabIndex        =   6
      Top             =   4560
      Width           =   1935
   End
   Begin VB.CommandButton cmdMeas 
      Caption         =   "Perform Measurement"
      Enabled         =   0   'False
      Height          =   375
      Left            =   720
      TabIndex        =   4
      Top             =   3840
      Width           =   1935
   End
   Begin VB.TextBox txtResource 
      Height          =   285
      Left            =   3120
      TabIndex        =   2
      Text            =   "GPIB0::24::INSTR"
      ToolTipText     =   "Change Resource Name as necessary for your Configuration"
      Top             =   1080
      Width           =   1935
   End
   Begin VB.CommandButton cmdOpen 
      Caption         =   "Open Session"
      Height          =   375
      Left            =   720
      TabIndex        =   1
      Top             =   1080
      Width           =   1935
   End
   Begin VB.Label Label2 
      Caption         =   $"measR.frx":0000
      Height          =   735
      Left            =   720
      TabIndex        =   15
      Top             =   5160
      Width           =   5295
   End
   Begin VB.Label lblReading 
      BackColor       =   &H8000000E&
      Caption         =   "reading......."
      Height          =   255
      Left            =   3000
      TabIndex        =   5
      Top             =   3840
      Width           =   2295
   End
   Begin VB.Label Label3 
      Caption         =   "Resource Name"
      BeginProperty Font 
         Name            =   "Small Fonts"
         Size            =   6
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   135
      Left            =   3120
      TabIndex        =   3
      Top             =   840
      Width           =   1215
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      BackColor       =   &H000000FF&
      Caption         =   "  KEITHLEY  "
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   18
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H8000000E&
      Height          =   435
      Left            =   360
      TabIndex        =   0
      Top             =   240
      Width           =   2295
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
'
'  Simple VB6 example for Ohms with Manual Resistance Mode of 2400.
'
'  Manual Resistance mode allows sourcing V and measuring I; or source I and
'  measure V.  The SourceMeter can actually return V, I and R as the reading.
'  This example tells it to just send us the R which it gets by sourcing
'  5 mA through the DUT.
'  The enableRemoteSensing function selects between 2-wire and 4-wire modes;  use VI_FALSE to use
'  2-wire mode instead.
'
'  Tested in Win98SE with VB6 using A01 (initial) release of the VXIPnP driver for
'  2400 Series SourceMeter Instruments (firmware C24)
'
'  In Project|References, include the Keithley 24xx driver
'
'
' use object browser (F2) or help file to
' better understand the parameters and variables
' help file location:  \program files\keithley instruments\24xx\help\
'
'
' declare some variables required by the driver
Dim session As ViSession
Dim status As ViStatus
Dim model As ViInt32
Dim speed As Double   ' used to program the NPLC setting of the SourceMeter
Private Sub cmdClose_Click()
' close this session
Ke24xx_close (session)
End
End Sub

Private Sub cmdMeas_Click()
Dim sourceRange, senseRange As ViInt32
Dim sourceCompliance As Double
Dim sourceLevel As Double
Dim reading As Single
Dim numReadings As ViInt32
' assign values......
sourceRange = KE24XX_10M_A_RANGE
senseRange = KE24XX_2_V_RANGE
sourceCompliance = 2  ' volts not to be exceeded.... 2 volts
sourceLevel = 0.005        ' amps to source.... 5mA

' clear our label
lblReading.Caption = "reading......"
DoEvents

' step 1:  configure the Source I, voltage compliance

status = Ke24xx_ConfigureSourceLevel(session, _
                                     KE24XX_SOURCE_CURRENT_FUNCTION, _
                                     sourceLevel, _
                                     KE24XX_SOURCE_LEVEL_TRIGGERED)
' error check
If status <> 0 Then DisplayError session, status
                                     
status = Ke24xx_ConfigureSourceCompliance(session, _
                                          KE24XX_SOURCE_CURRENT_FUNCTION, _
                                          sourceCompliance)

' error check
If status <> 0 Then DisplayError session, status

status = Ke24xx_ConfigureSourceMode(session, _
                                    KE24XX_SOURCE_CURRENT_FUNCTION, _
                                    KE24XX_SOURCE_FIXED_MODE, _
                                    KE24XX_SOURCE_DC_SHAPE, _
                                    sourceRange)

' error check
If status <> 0 Then DisplayError session, status

'  step 2:  configure resistance measurement

status = Ke24xx_ConfigureRESSense(session, _
                                  KE24XX_200_OHMS_RANGE, _
                                  speed, _
                                  KE24XX_MANUAL_OHMS, _
                                  VI_TRUE)  ' offset compensation on
                            
' error check
If status <> 0 Then DisplayError session, status
                                  
' enable 4-wire or 2-wire ohms mode
If opt2WIRE.Value = True Then
status = Ke24xx_EnableRemoteSensing(session, VI_FALSE)
Else
status = Ke24xx_EnableRemoteSensing(session, VI_TRUE)
End If

' configure which parameter to send back in the reading:  volts, current, resistance
status = Ke24xx_SelectSenseFunc(session, VI_FALSE, VI_FALSE, VI_TRUE)
                                       ' volts    current     resistance
' error check
If status <> 0 Then DisplayError session, status
                                
' step 3: turn on the output
status = Ke24xx_EnableSourceOutput(session, True)  ' turn it on
If status <> 0 Then DisplayError session, status
' step 4: take the reading
Const KI24XX_READ_RESISTANCE = 4  ' from the help file
status = Ke24xx_Read(session, KI24XX_READ_RESISTANCE, numReadings, reading)
If status <> 0 Then DisplayError session, status
' stop 5: turn off the output
status = Ke24xx_EnableSourceOutput(session, False)  ' turn it off
If status = 0 Then
lblReading.Caption = Format(reading, "##.###0") & " ohms"  ' display the reading
Else
lblReading.Caption = "Error has occured...."
DisplayError session, status
End If
End Sub

Private Sub cmdOpen_Click()
status = Ke24xx_init(txtResource.Text, model, session)

If status <> 0 Then
MsgBox "Could not open a session.  Verify the address of your SourceMeter", vbCritical
Else
status = Ke24xx_reset(session)  ' reset the instrument
status = Ke24xx_EnableBeeper(session, VI_FALSE)  ' turn off the instrument's beeper
speed = 1  ' set the speed, NPLC, equal to an initial value that agrees with the option buttons
cmdMeas.Enabled = True          ' enable other command button
cmdOpen.Enabled = False         ' disable this button
End If
End Sub
   
Public Function DisplayError(sesn As ViSession, nErr As ViStatus)

Dim errMsg As String * 256
Dim err As ViStatus
Dim code As ViInt32


    If nErr = KE24XX_DEVICE_ERROR Then
        err = Ke24xx_GetLastError(sesn, code, errMsg)
        MsgBox "Error = " & Str(code) & "  " & errMsg, vbOKOnly
    Else
        err = Ke24xx_error_message(sesn, nErr, errMsg)
        If err <> 0 Then
            MsgBox "Error= " & Hex(nErr), vbOKOnly
        Else
            MsgBox "Error= " & Hex(nErr) & "  " & errMsg, vbOKOnly
        End If
    End If
End Function


Private Sub optNPLC_Click(Index As Integer)
' NPLC: number of power line cycles....0.01 to 10
' small number = fast at expense of precision
Select Case Index
Case 0
speed = 0.01
Case 1
speed = 0.1
Case 2
speed = 1
Case 3
speed = 10
End Select
End Sub
